(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
(*  Soubor: CRPLUS.PAS                                                     *)
(*  Obsah: program pro prevod textovych souboru z formatu LF na CRLF       *)
(*  Autor: Mircosoft (http://mircosoft.mzf.cz)                             *)
(*  Posledni uprava: 7.1.2015                                              *)
(*  Pro kompilaci: DISK.TPU, (DOS.TPU)                                     *)
(*  Pro spusteni: nic                                                      *)
(*  Upozorneni: tyto zdrojove kody pouzivate na vlastni nebezpeci          *)
(* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *)
program crlf;
uses dos,disk; {kvuli dlouhym jmenum (pro cisty DOS nebo windowsovsky prekladac lze zrusit)}
const VelBaf=20000; {velikost bufferu}
      DocasneJmeno='CRPLUS.$$$'; {docasne jmeno pro vystupni soubor}
var vstup,vystup:file;
    jmeno:string[79]; {jmeno vstupniho souboru}
    bafr1:array[1..velbaf] of char; {cteci buffer pro vstupni soubor}
    bafr2:array[1..2*velbaf] of char; {zapisovaci buffer pro vystupni soubor
    (pridane CR to teoreticky muzou nafouknout az na dvojnasobek, proto to *2)}
    nacteno,kZapsani,w:word;
    bylo13:boolean;
    znak:char; {pro usetreni pristupu k poli}
BEGIN
{$I-}
writeln('Program na prevod koncu radku v textovych souborech do formatu CRLF');
writeln('                        (c) Mircosoft 2015');
writeln;
if (paramcount<>0)and(paramstr(1)='/?')
  then begin
       writeln('Pouziti:');
       writeln;
       writeln('Soubor ke zpracovani predejte bud jako parametr (DOS: CRPLUS.EXE blabla.txt,');
       writeln('Windows: Otevrit v programu -> Jiny -> Prochazet -> CRPLUS.EXE) nebo ho');
       writeln('napiste rucne.');
       writeln;
       writeln('Konce radku ve tvaru CR (ASCII 13) nebo LF (ASCII 10) se prevedou na tvar CRLF.');
       writeln('Existujici konce ve tvaru CRLF se podruhe neprevadeji, takze opakovane');
       writeln('pouziti programu na stejny soubor neni na skodu.');
       writeln;
       writeln('Pochopitelne to nezkousejte na nic jineho nez textove soubory (TXT, HTML');
       writeln('apod.). Binarni soubory (DOC, EXE, ZIP atd.) program neopravitelne poskodi.');
       writeln;
       writeln('Stisknete Enter...'); readln;
       halt;
       end;
if paramcount=0 then begin
                     writeln('Jmeno souboru k preformatovani (nebo samotny Enter pro konec):');
                     readln(jmeno);
                     if jmeno='' then begin
                                      writeln('Zruseno.');
                                      halt;
                                      end;
                     end
                else jmeno:=paramstr(1);
write('Pracuji...');
assign(vstup,jmeno);
assign(vystup,docasnejmeno);
reset(vstup,1);
if ioresult<>0 then begin
                    writeln(' vstupni soubor neexistuje.');
                    halt;
                    end;
rewrite(vystup,1);
if ioresult<>0 then begin
                    writeln(' disk je chraneny proti zapisu.');
                    close(vstup); w:=ioresult;
                    halt;
                    end;
{Tim mame osetrene nejbeznejsi chyby souboru. Poskozene soubory nebo
nedostatek mista na disku jsou natolik vzacne, ze nema cenu pro ne pripravovat
chybove hlasky, takze pro zbytek programu zapinam automatiku:}
{$I+}
bylo13:=false;
while not eof(vstup) do
 begin
 blockread(vstup,bafr1,velbaf,nacteno);
 kzapsani:=0;
 for w:=1 to nacteno do {pro kazdy nacteny znak ve vstupnim bufferu}
  begin
  znak:=bafr1[w];
  if bylo13 then begin {minuly znak byl CR...}
                 if znak<>#10 then begin {...a ted za nim chybi LF: pridej ho}
                                   inc(kzapsani);
                                   bafr2[kzapsani]:=#10;
                                   end;
                 end
            else begin {minuly znak nebyl CR...}
                 if znak=#10 then begin {...a ted je tu samotne LF: pridej CR}
                                  inc(kzapsani);
                                  bafr2[kzapsani]:=#13;
                                  end;
                 end;
  {ted konecne zapiseme ten aktualni znak:}
  inc(kzapsani);
  bafr2[kzapsani]:=znak;
  bylo13:=znak=#13; {pro priste}
  end;
 blockwrite(vystup,bafr2,kzapsani);
 end;
close(vstup); close(vystup);
writeln(' hotovo.');
erase(vstup);
lrename(docasnejmeno,jmeno); {nejdriv pokus o prejmenovani s dlouhym jmenem}
if doserror<>0 then begin {a kdyby to nevyslo, tak standardne s kratkym}
                    writeln('(pouzito zkracene jmeno)');
                    rename(vystup,jmeno);
                    end;
END.